async function onBeforeRequest(options) {
  if(options.frameId !== 0 || options.tabId === -1) {
    return {};
  }

  let tab = await browser.tabs.get(options.tabId);

  if(options.url.indexOf('example') !== -1) {
    const extURL = browser.extension.getURL("/background.html");
    let url = `${extURL}?tabId=${tab.id}&windowId=${tab.windowId}`
    return {
      redirectUrl: url
    };
  }

  return {};
}

browser.webRequest.onBeforeRequest.addListener(onBeforeRequest, {urls: ["<all_urls>"], types: ["main_frame"]}, ["blocking"]);
browser.tabs.onCreated.addListener((tab) => {
  browser.browserAction.setBadgeText({
    tabId: tab.id,
    text: tab.id.toString()
  });
});
